<?php
/* Autor...:  */
/* Esquema.: MST_ReferenciaProductoColor.xml */
/* Generado: 2024-08-02 05:22:56 */

/* Metodos de acceso a los campos de la tabla MST_ReferenciaProductoColor */
abstract class BaseMST_ReferenciaProductoColorBN
{
    /* Campos de la tabla */
    private $i_IdReferencia;    // IdReferencia: ( no definido )
    private $i_IdColor;    // IdColor: ( no definido )
    private $i_ImagenFlag;    // ImagenFlag: ( no definido )
    private $s_ImagenReferenciaNombre;    // ImagenReferenciaNombre: ( no definido )
    private $s_ImagenReferenciaFisico;    // ImagenReferenciaFisico: ( no definido )
    private $s_ImagenReferenciaWeb;    // ImagenReferenciaWeb: ( no definido )
    private $d_FechaCreacion;    // FechaCreacion: ( no definido )
    private $s_UsuarioCreacion;    // UsuarioCreacion: ( no definido )
    private $d_FechaModificacion;    // FechaModificacion: ( no definido )
    private $s_UsuarioModificacion;    // UsuarioModificacion: ( no definido )

    /* Establece el valor del campo IdReferencia */
    public function setIdReferencia( $i_IdReferencia )
    {
        $this->i_IdReferencia = $i_IdReferencia;
    }

    /* Obtiene el valor del campo IdReferencia */
    public function getIdReferencia()
    {
        return $this->i_IdReferencia;
    }

    /* Establece el valor del campo IdColor */
    public function setIdColor( $i_IdColor )
    {
        $this->i_IdColor = $i_IdColor;
    }

    /* Obtiene el valor del campo IdColor */
    public function getIdColor()
    {
        return $this->i_IdColor;
    }

    /* Establece el valor del campo ImagenFlag */
    public function setImagenFlag( $i_ImagenFlag )
    {
        $this->i_ImagenFlag = $i_ImagenFlag;
    }

    /* Obtiene el valor del campo ImagenFlag */
    public function getImagenFlag()
    {
        return $this->i_ImagenFlag;
    }

    /* Establece el valor del campo ImagenReferenciaNombre */
    public function setImagenReferenciaNombre( $s_ImagenReferenciaNombre )
    {
        $this->s_ImagenReferenciaNombre = $s_ImagenReferenciaNombre;
    }

    /* Obtiene el valor del campo ImagenReferenciaNombre */
    public function getImagenReferenciaNombre()
    {
        return $this->s_ImagenReferenciaNombre;
    }

    /* Establece el valor del campo ImagenReferenciaFisico */
    public function setImagenReferenciaFisico( $s_ImagenReferenciaFisico )
    {
        $this->s_ImagenReferenciaFisico = $s_ImagenReferenciaFisico;
    }

    /* Obtiene el valor del campo ImagenReferenciaFisico */
    public function getImagenReferenciaFisico()
    {
        return $this->s_ImagenReferenciaFisico;
    }

    /* Establece el valor del campo ImagenReferenciaWeb */
    public function setImagenReferenciaWeb( $s_ImagenReferenciaWeb )
    {
        $this->s_ImagenReferenciaWeb = $s_ImagenReferenciaWeb;
    }

    /* Obtiene el valor del campo ImagenReferenciaWeb */
    public function getImagenReferenciaWeb()
    {
        return $this->s_ImagenReferenciaWeb;
    }

    /* Establece el valor del campo FechaCreacion */
    public function setFechaCreacion( $d_FechaCreacion )
    {
        $this->d_FechaCreacion = $d_FechaCreacion;
    }

    /* Obtiene el valor del campo FechaCreacion */
    public function getFechaCreacion()
    {
        return $this->d_FechaCreacion;
    }

    /* Establece el valor del campo UsuarioCreacion */
    public function setUsuarioCreacion( $s_UsuarioCreacion )
    {
        $this->s_UsuarioCreacion = $s_UsuarioCreacion;
    }

    /* Obtiene el valor del campo UsuarioCreacion */
    public function getUsuarioCreacion()
    {
        return $this->s_UsuarioCreacion;
    }

    /* Establece el valor del campo FechaModificacion */
    public function setFechaModificacion( $d_FechaModificacion )
    {
        $this->d_FechaModificacion = $d_FechaModificacion;
    }

    /* Obtiene el valor del campo FechaModificacion */
    public function getFechaModificacion()
    {
        return $this->d_FechaModificacion;
    }

    /* Establece el valor del campo UsuarioModificacion */
    public function setUsuarioModificacion( $s_UsuarioModificacion )
    {
        $this->s_UsuarioModificacion = $s_UsuarioModificacion;
    }

    /* Obtiene el valor del campo UsuarioModificacion */
    public function getUsuarioModificacion()
    {
        return $this->s_UsuarioModificacion;
    }

    public function getJsonSerialize()
    {
        return 
        [
            'IdReferencia' => $this->getIdReferencia(),
            'IdColor' => $this->getIdColor(),
            'ImagenFlag' => $this->getImagenFlag(),
            'ImagenReferenciaNombre' => $this->getImagenReferenciaNombre(),
            'ImagenReferenciaFisico' => $this->getImagenReferenciaFisico(),
            'ImagenReferenciaWeb' => $this->getImagenReferenciaWeb(),
            'FechaCreacion' => $this->getFechaCreacion(),
            'UsuarioCreacion' => $this->getUsuarioCreacion(),
            'FechaModificacion' => $this->getFechaModificacion(),
            'UsuarioModificacion' => $this->getUsuarioModificacion(),
        ];
    }

    public function toArray()
    {
        return $this->processArray( get_object_vars( $this ) ); 
    }

    private function processArray( $array )
    {
        foreach( $array as $key => $value ) 
        {
            if ( is_object( $value ) )
            {
                $array[$key] = $value->toArray();
            }
            if ( is_array( $value ) ) 
            {
                $array[$key] = $this->processArray( $value );
            }
        }
        return $array;
    }

    public function __toString()
    {
        return json_encode( $this->toArray() ); 
    }

    /* Recupera un objeto MST_ReferenciaProductoColorBN desde un RecordSet */
    public static function retrieveByRs( $o_MST_ReferenciaProductoColorRs )
    {
        $o_MST_ReferenciaProductoColorBN = new MST_ReferenciaProductoColorBN();
        $o_MST_ReferenciaProductoColorBN->setIdReferencia( ( integer ) $o_MST_ReferenciaProductoColorRs[ "IdReferencia" ] );
        $o_MST_ReferenciaProductoColorBN->setIdColor( ( integer ) $o_MST_ReferenciaProductoColorRs[ "IdColor" ] );
        $o_MST_ReferenciaProductoColorBN->setImagenFlag( ( integer ) $o_MST_ReferenciaProductoColorRs[ "ImagenFlag" ] );
        $o_MST_ReferenciaProductoColorBN->setImagenReferenciaNombre( $o_MST_ReferenciaProductoColorRs[ "ImagenReferenciaNombre" ] );
        $o_MST_ReferenciaProductoColorBN->setImagenReferenciaFisico( $o_MST_ReferenciaProductoColorRs[ "ImagenReferenciaFisico" ] );
        $o_MST_ReferenciaProductoColorBN->setImagenReferenciaWeb( $o_MST_ReferenciaProductoColorRs[ "ImagenReferenciaWeb" ] );
        $o_MST_ReferenciaProductoColorBN->setFechaCreacion( utilTimestamp::getTimestamp( $o_MST_ReferenciaProductoColorRs[ "FechaCreacion" ], "Y-m-d H:i:s" ) );
        $o_MST_ReferenciaProductoColorBN->setUsuarioCreacion( $o_MST_ReferenciaProductoColorRs[ "UsuarioCreacion" ] );
        $o_MST_ReferenciaProductoColorBN->setFechaModificacion( utilTimestamp::getTimestamp( $o_MST_ReferenciaProductoColorRs[ "FechaModificacion" ], "Y-m-d H:i:s" ) );
        $o_MST_ReferenciaProductoColorBN->setUsuarioModificacion( $o_MST_ReferenciaProductoColorRs[ "UsuarioModificacion" ] );
        return $o_MST_ReferenciaProductoColorBN;
    }
}
?>